=== debian/changelog ===
zoneminder (1.32.3-2ubuntu2) focal; urgency=medium

  * d/p/mysql8-replace-password-call.patch: updated to also include
    the password() call in zm_create.sql.in which was previously
    incorrectly patched in the (now removed) mysql8-password-deprecated.patch
    patch. Thanks to Joseph Yasi <joe.yasi@gmail.com>.
  * d/README.Debian: remove syntax error in the new mysql8 instructions

 -- Andreas Hasenack <andreas@canonical.com>  Tue, 25 Feb 2020 13:57:29 -0300

zoneminder (1.32.3-2ubuntu1) focal; urgency=medium

  * d/p/mysql8_my_bool.patch: Reintroduce my_bool to fix build with MySQL 8.
    (LP: #1863026)
  * d/rules: override build-dep to fix FTBFS (thanks to
    robie.basak@canonical.com) (LP: #1863793, Closes: #951600)
  * MySQL8 runtime fixes (LP: #1859295):
    - d/p/mysql8-password-deprecated.patch: password() is deprecated
    - d/p/mysql8-reserved-keywords.patch: quote MySQL8 reserved keywords
    - d/p/mysql8-replace-password-call.patch: replace password()
  * d/README.Debian: quick update for MySQL8 and Focal

 -- Andreas Hasenack <andreas@canonical.com>  Tue, 25 Feb 2020 10:22:20 -0300

zoneminder (1.32.3-2build1) eoan; urgency=medium

  * No change rebuild for libmysqlclient21.

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Thu, 15 Aug 2019 09:35:22 +0200

zoneminder (1.32.3-2) unstable; urgency=high

  * Upload to unstable.
  * New upstream patches:
    + CVE-2019-6777 (Closes: #920375).
    + CVE-2019-6992 (Closes: #920999).
    + CVE-2019-6991 (Closes: #921000).
    + CVE-2019-6990 (Closes: #921001).
    + Fix for "image size is not multiples of 12 and 64".
  * Removed broken symlink (Closes: #915681).
  * Standards-Version: 4.3.0.
  * Build-Depends:
    - libmp4v2-dev

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 11 Feb 2019 13:00:00 +1100

zoneminder (1.32.3-1) experimental; urgency=medium

  * New upstream release.
  * Default to ZM_PATH_ARP="/bin/ip neigh"

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 13 Dec 2018 10:57:50 +1100

zoneminder (1.32.2-1) experimental; urgency=medium

  * New upstream release.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 14 Oct 2018 17:29:55 +1100

zoneminder (1.32.1-3) experimental; urgency=medium

  * Another attempt to fix FTBFS on [armel] by new patch from upstream.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 13 Oct 2018 12:25:52 +1100

zoneminder (1.32.1-2) experimental; urgency=medium

  * New patch to fix API import paths.
  * New upstream patch to fix FTBFS on [armel].

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 11 Oct 2018 13:52:34 +1100

zoneminder (1.32.1-1) experimental; urgency=medium

  * New upstream release.
  * Build-Depends:
    + libavresample-dev
    + libmp4v2-dev
    + libx264-dev
  * Depends:
    + php-json
    - policykit-1
  * Suggests += "policykit-1".

 -- Dmitry Smirnov <onlyjob@debian.org>  Tue, 09 Oct 2018 11:54:51 +1100
